Unit Struc130;
{$H-}

Interface

Const
  maxconf=200;

Type


  Flagdb2= packed record
            filename:string[12];
            confnr:SmallInt;
            size:longint;
            fileliste:SmallInt;
            free:boolean;
            del:boolean;
          end;


  ProtRec=packed RECORD                {Record over file protocols}
              ProtDesc        : ARRAY[1..10] OF STRING[20];
              ProtSeclvl      : ARRAY[1..10] OF BYTE;
              ProtUPBAT       : ARRAY[1..10] OF STRING[7];
              ProtDOWNBAT     : ARRAY[1..10] OF STRING[7];
            END;

  trans=packed RECORD
          sent:BOOLEAN;           {True if send.False if recieved}
          filepath:STRING[80];    {Full pathstring INCLUDING filename.}
          FileName:STRING[12];    {filename}
          filecps:WORD;           {Transfer rate in CPS}
          FILESIZE:LONGINT;       {File's physical size. -1 if not known}
          fileerror:BOOLEAN;      {Error file.File was not completly sent nor recieved}
        END;

  Conrec = packed RECORD
              ConfName    : String[16];
              Confpath    : String[66];
              ConfFiles   : Array[1..9] of String[66];
              confFHigh   : SmallInt;
              CONFFreeDown: BOOLEAN;
              ConfFileArea: BOOLEAN;
              confmsgarea : Boolean;
              ConfNetMail : BOOLEAN;
              cdrom       : ARRAY[1..9] of BOOLEAN;
              CONFPWD     : String[15];
           END;

  upsrec = packed RECORD
             ups : ARRAY[1..maxconf] OF WORD;
             upshold : ARRAY[1..maxconf] OF WORD;
             downs : ARRAY[1..maxconf] OF WORD;
           END;

  partup = packed RECORD
             Name : STRING[30];
             FName : STRING[12];
             conf : SmallInt;
             complete : BOOLEAN;
             date : STRING[12];
           END;

  TextRec = RECORD
            data : STRING[80];
            END;

  lastcallersrecord = packed RECORD
                        node : BYTE;
                        Name : STRING[30];
                        location : STRING[30];
                        date : STRING[8];
                        logontime : STRING[8];
                        logofftime : STRING[8];
                        baudrate : STRING[6];
                        times : WORD;
                        download : BOOLEAN;
                        upload : BOOLEAN;
                        posted : BOOLEAN;
                        READ : BOOLEAN;
                        wantedchat : BOOLEAN;
                        chated : BOOLEAN;
                        nodechat : BOOLEAN;
                        hidden : BOOLEAN;
                        useddoors : BOOLEAN;
                        {User used a door}
                        attribute : BYTE;
                        scanned : BOOLEAN;
                        { Scanned files - Used either 'f' or 'N' }
                        lostcarrier : BOOLEAN;
                        { Lost Carrier - Didnt use 'g' }
                        hacking : BOOLEAN;
 { Attempted to log in under an account - but didnt know password
   - Makes a Lastcall record for them as well...}
                        downs,
                        ups : SmallInt;
                        {# Files Uploaded, Downloaded }
                        downk,
                        upk : LONGINT;
                        {# Bytes Uploaded/Downloaded }
                      END;

  bbsrecord = packed RECORD
                totalcalls : LONGINT;
                lastupdated : STRING[12];
                tcalls : WORD;    (* Today *)
                tmsgall : WORD;
                tmsgto : WORD;
                tdl : WORD;
                tul : WORD;
                tdlbytes : LONGINT;
                tulbytes : LONGINT;
                tprivateul : WORD;
                tnewusers : WORD;
                tpagerequests : WORD;
                TFaxReceived:Word;
                TLater     :Word;

                scalls : WORD;    (* Since SYSOP loged on *)
                smsgall : WORD;
                smsgto : WORD;
                sdl : WORD;
                sul : WORD;
                sdlbytes : LONGINT;
                sulbytes : LONGINT;
                sprivateul : WORD;
                snewusers : WORD;
                spagerequests : WORD;
                SFaxReceived   : Word;
                SLater        : Word;

                tdowncps,
                tupcps : SmallInt;
                tdownname,
                tupname : STRING[30];
 { This can be used when a user selects to upload or download
  and it says 'Top System Download Cps by XXXXXXXXXX at [XXXX] Cps }

              END;

  multinoderecord = packed RECORD
                      Name : STRING[30];
                      location : STRING[30];
                      baudrate : WORD;
                      filelock : STRING[255];
                      donotdisturb : BOOLEAN;
                      status : BYTE;
                      line : BYTE;
                      extendedstatus : STRING[20];
                      {IE What door a user is using or what file is being transferred }
                      conference : SmallInt;
                      {Current Conference Number User is In!}
                    END;

   {IF  status = CHECK FOR MORE INFORATION THE WHATNEW.DOC

    }



  chatrecord = RECORD
                 chatonoff : BOOLEAN;
                 timeonoff : BOOLEAN;
                 startchat : ARRAY[1..7] OF STRING[5];
                 stoppchat : ARRAY[1..7] OF STRING[5];
               END;

  userrecord = packed RECORD
                 Name,
                 location : STRING[30];
                 pwd,
                 phone : STRING[15];
                 lasttime,
                 lastdate,
                 firstdate,
                 birthdate,
                 subdate : STRING[8];

                 highmsgread : ARRAY[1..maxconf] OF SmallInt;
                 highmsgauto : ARRAY[1..maxconf] OF SmallInt;

                 timesposted,
                 timesrecived,
                 seclvl,
                 times,
                 ups,
                 downs,
                 ratio,
                 ratiotype,
                 lines,
                 computertype,
                 timeday,
                 time : WORD;

                 lastconf   : SmallInt;
                 confaccess : Array[1..maxconf] of Boolean;

                 downbday,
                 todaydown,
                 upk,
                 downk : LONGINT;

                 extra,
                 cleared,
                 hidden,
                 deleted,
                 elite,
                 pause,
                 sendclearscreen,
                 nokill,
                 fullscreen,
                 filelistcolors,
                 subenabled,
                 transferlimitsoverride,
                 vip : BOOLEAN;

                 dateformat : BYTE;
                 groups : ARRAY[1..10] OF BYTE;
                 { 10 sets of 8 bit flags}
                 comment : STRING[45];
                 weekup : LONGINT; {For use by utilities}
                 weekdown : LONGINT; {For use by utilities}
                 expirepreset : BYTE; {What preset the user should have after expiration}
                 topupcps : WORD; {Users topcps}
                 topdowncps : WORD; {Users topcps}
                 creditbytes : LONGINT;
                 creditfiles : SmallInt;
 { Used to Credit User's a certain amount of bytes for download,
  This can be used in the following way :
    When the user selects to download the bytes or Files are FIRST taken off
   their bytes/files and then added to their download if the fields hit 0.
   This would be useful for things like - giving new users a certain amount of
   files/k they can download before having to worry about ratios, for paying
   users on systems, or for utils such as faker or games where users are given
   credits... This would anull users from being put on downloader charts, and
   would not muck up other top downloader per week/month etc type stuff and
   guarantee anomnity for users without having to make them hidden}
                 ibmansi : BOOLEAN;
 { This could be changed by the user with the 'W' command. This would be true
  if the user supported IBM Ansi type chars  which cannot be seen under normal
  circumstances by amiga/st/mac etc users }
                 avatar : BOOLEAN;
                 { For Avatar type gfx support - as above }
                 monthup,
                 monthdown : LONGINT;
 {As with weekly but for month! - Good for systems who dont have a huge amount
  of file xfer activity }
                 protocol : BYTE;
 { Default Download/Upload Protocol - Zmodem, Ymodem, HS-Link etc. - For when
  it is supported or for external doors. }

                 { since PC-Expres V1.19}

                 HACKED_Times:BYTE; { if this byte is 3 user will be locked}
                 Reset_Time:Boolean; {after logoff day time again 0}
                 Reset_downdbytes:Boolean;{after logoff todaydownbytes := 0}
                 Sent_by:String[45];      {users own send by string}
                 version:byte;
                 sprache:byte;
                 gms_art:boolean;
                 Last_PW_Change : String[8];
                 future : array[1..439] of byte;

               END;


  configrec = packed RECORD

                versionid : BYTE;

                comport,
                baudrate,
                parity,
                stopbits,
                charlength,
                inittries,
                screenblanktime : WORD;

                initstring,
                okstring,
                hangupstring,
                busystring,
                answerstring,
                ringstring : STRING[80];

                bbsname : STRING[30];
                bbssysop : STRING[30];

                monomode : BOOLEAN;

                connect300, connect1200, connect2400,
                connect4800, connect9600, connect12000,
                connect14400, connect16800, connect19200,
                connect21600, connect28800, connect38400,
                connect57600, connect64000, connect115200,
                mnpstring : STRING[20];

                CONNECTFAX : STRING[30];

                callingtimestart,
                callingtimestop : ARRAY[1..7] OF STRING[5]; (* Calling times Limit *)

                downloadtimestart,
                downloadtimestop : ARRAY[1..7] OF STRING[5]; (* Downloading timelimit *)

                callingtimestoponoff : ARRAY[1..7] OF BOOLEAN; (* Downloading timelimit *)
                downloadtimestoponoff : ARRAY[1..7] OF BOOLEAN; (* Downloading timelimit *)

                newuserfilter : ARRAY[1..7] OF BYTE; (* 0 = YES  1 = No 2 = No New  3 = Password *)

                newuserpassword : ARRAY[1..7] OF STRING[15]; (* New UserPassWord *)


                computertypes : ARRAY[0..19] OF STRING[15];

                newprivlevel,
                newratio,
                newratiotype,
                newtimelevel : SmallInt;
                newconflevel : array[1..maxconf] of BOOLEAN;
                newdownbday  : LONGINT;

                systempass,
                shellpass : STRING[15];

                pwdtries : BYTE;
                minpwdlength : BYTE;

                TEXT, path : STRING[60];

                ad1, ad2, ad3, ad4 : STRING[10];

                sentby : BYTE;
                sentbystring : STRING[60];

                secl : ARRAY[1..150] OF BYTE;

                options : ARRAY[1..150] OF BOOLEAN;

                maincolors : ARRAY[1..20] OF BYTE;

                minspace : LONGINT;

                systemeventslast : ARRAY[1..20] OF STRING[6];

                valueoption : ARRAY[1..40] OF WORD;

                newuserstartconf : SmallInt;

                reservebbsname : STRING[30];

                reservetime : STRING[6];

                reservehold : WORD;

                presetprivlevel : ARRAY[1..5] OF BYTE;
                presetconflevel : ARRAY[1..5,1..maxconf] OF BOOLEAN;
                presetratio : ARRAY[1..5] OF SmallInt;
                presetratiotype : ARRAY[1..5] OF BYTE;
                presettimelevel : ARRAY[1..5] OF SmallInt;
                presetdownbday : ARRAY[1..5] OF LONGINT;

                chatsysop,
                chatuser : STRING[10];

                deletedstring : STRING[16];
                sentbycustom : STRING[50];
                sentbylrc : BYTE;


                doorname : ARRAY[1..100] OF STRING[8];
                doorlvl : ARRAY[1..100] OF BYTE;
                doorconf : ARRAY[1..100] OF SmallInt;

                doorwrite : ARRAY[1..100] OF BOOLEAN;
                irq : BYTE;
                ioaddr : WORD;
                comhandler : BYTE; (* 0: UART/Direct  1: BIOS calls
                                  2: Fossil       3: Digi14      *)
               modemdelay:longint;
               regstring       : string[35];
               scandrives      : string[12];
               transwin        : byte;

               {since PC-Express V1.19}

               connect24000,connect26400 : String[20];
               timedoor_time    : string[5];
               file_id_length   : byte;
               file_id_time     : byte;
               accesstime       : array [1..24] of byte;
               chattime         : array [1..14] of string[5];
               SYSpwFIRST       :BOOLEAN;
               screen80x50      :boolean;

               bbslocation      :string[30];
               sprache          : array[1..10] of string[20];
               Connect22400     : STRING[20];
               DUPE_CHECK       : array[1..10] of Boolean;
               Connect31200     : STRING[20];
               Connect33600     : STRING[20];
               SysopString      : String[40];
               ConnectVoice     : String[20];
               passowrd_days    : Byte;
               futureexpand     :array[1..9563] of byte;

              END;

  doorinfo = packed RECORD
               name,
               location : STRING[30];
               pwd,
               phone : STRING[15];
               lasttime,
               lastdate,
               firstdate,
               birthdate,
               subdate : STRING[8];

               highmsgread : ARRAY[1..maxconf] OF SmallInt;
               highmsgauto : ARRAY[1..maxconf] OF SmallInt;

               confaccess : array[1..maxconf] of boolean;

               timesposted,
               timesrecived,
               seclvl,
               lastconf,
               times,
               ups,
               downs,
               ratio,
               ratiotype,
               lines,
               computertype,
               timeday,
               time : WORD;

               downbday,
               todaydown,
               upk,
               downk : LONGINT;

               extra,
               cleared,
               hidden,
               deleted,
               elite,
               pause,
               sendclearscreen,
               nokill,
               fullscreen,
               filelistcolors,
               subenabled,
               transferlimitsoverride,
               vip : BOOLEAN;

               dateformat : BYTE;
               groups : ARRAY[1..10] OF BYTE;
               comment : STRING[45];
               weekup : LONGINT;
               weekdown : LONGINT;
               expirepreset : BYTE;
               topupcps : WORD;
               topdowncps : WORD;
               creditbytes : LONGINT;
               creditfiles : SmallInt;
               ibmansi : BOOLEAN;
               avatar : BOOLEAN;
               monthup,
               monthdown : LONGINT;
               protocol : BYTE;


               lcdownload : BOOLEAN; {Theese are the same as in the}
               lcupload : BOOLEAN; {LastCallersRecord just with a lc}
               lcposted : BOOLEAN; {infront to avoid double names}
               lcread : BOOLEAN;
               lcwantedchat : BOOLEAN;
               lcchated : BOOLEAN;
               lcnodechat : BOOLEAN;
               lchidden : BOOLEAN;
               lcuseddoors : BOOLEAN;
               lcattribute : BYTE;
               lcscanned : BOOLEAN;
               lclostcarrier : BOOLEAN;
               lchacking : BOOLEAN;
               lcdowns,
               lcups : SmallInt;
               lcdownk,
               lcupk : LONGINT;
               PORT : BYTE;
               buadrate : LONGINT;
               lockedrate : LONGINT;
               currentconf : BYTE;
               nodenum : BYTE;
               timeleft : SmallInt;
               ansi : BOOLEAN;
               usernum : WORD;
               parameters : STRING[60]; {Parameters passed to door IE:}
               {user enters N S U then the door N}
               {will be opened and S U is parameter}
               local : BOOLEAN;
               commporttype : BYTE;
               commportadress : WORD;
               commportirq : BYTE;

               {since pce V1.19}
               HACKED_Times:BYTE; { if this byte is 3 user will be locked}
               Reset_Time:Boolean; {after logoff day time again 0}
               Reset_downdbytes:Boolean;{after logoff todaydownbytes := 0}
               Sent_by:String[45];       {users own send by string}
               language:byte;
               gms_art:boolean;
               futureexp : ARRAY[1..265] OF BYTE;
             END;

   FlagdbDOOR=packed record
                filename:string[12];
                confnr:SmallInt;
                size:longint;
                fileliste:SmallInt;
                free:boolean;
              end;



  resumerecord = RECORD
                   FileName : STRING[12];
                   conf : BYTE;
                   bytesup : LONGINT;
                   username : STRING[30];
                 END;

  Event_Data = Record
                j,
                m,
                t        :word;
            {    more : array[1..1000] of byte;}
               end;

Implementation
End.
